#!/bin/bash
kubectl delete KongPlugin app-jwt-kp -n nonrtric

kubectl delete Secret pms-jwt-sec -n nonrtric
kubectl delete Secret ecs-jwt-sec -n nonrtric
kubectl delete Secret app-admin-jwt-sec -n nonrtric
kubectl delete Secret app-user-jwt-sec -n nonrtric

kubectl delete KongPlugin pms-group-acl-kp -n nonrtric
kubectl delete KongPlugin ecs-group-acl-kp -n nonrtric

kubectl delete Secret pms-group-acl-sec -n nonrtric
kubectl delete Secret ecs-group-acl-sec -n nonrtric

kubectl delete KongConsumer pms-user-kc -n nonrtric
kubectl delete KongConsumer ecs-user-kc -n nonrtric
kubectl delete KongConsumer admin-kc -n nonrtric
kubectl delete KongConsumer plain-user-kc -n nonrtric

kubectl delete Ingress r1-pms-ing -n nonrtric
kubectl delete Ingress r1-ecs-ing -n nonrtric
kubectl delete Ingress demo-get-ing -n nonrtric
kubectl delete Ingress demo-post-ing -n nonrtric

if [ $# -eq 1 ]; then
  exit 0
fi

export ADMJWT=eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiYWRtaW4iOnRydWUsImlhdCI6MTUxNjIzOTAyMiwiaXNzIjoiYWRtaW4taXNzdWVyIn0.o-cRrn8kN47vKrOTCI1p0mc94872JmY8tZFD9gBnSGExC0T7IcUJ691PdMJ2440LBekZ486-Phyv6X2TFwxRlzW1k-TuZNVYqg-oxDTOHNkhbil7WGP15T8aL0giNBS6hRFllkXWM-8_vm06ZyOjPWD0A8n_mdAGkpT9ZwiMymSE7YjoO5WN-6rVv4rH7rp5JjP2wguLcJuM43QzV-CuprsKujguywkdMjqoN8-4uv8cPQ1olL4auCf_x_rvN0zCwr-4Ha3C1iUEn-ch40YNHSQ9Vy_XK2NIK3pPWnpFcOQkYtmu8iCv4c2sq5bt6aicTsygONiL03FvsWWiImbewQ
export USERJWT=eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiYWRtaW4iOnRydWUsImlhdCI6MTUxNjIzOTAyMiwiaXNzIjoidXNlci1pc3N1ZXIifQ.E1GQVhSuSYoZaluCMdDv9oxLr8f0jEXRjGr0Qyovq-Y2254X33ic67G0lnmH6U3x7dmwApiewlnCERPcEZXd8MiZWL5ebGOCsgtMvrCUC3JjbXgvbY2zzDS87u2B8aZWZIqgfR0ZheaqnhvGe7nYCIm-7KbVnY3w_d-h0YZYdaS7CZgELvjXWY8I546sIxxtSUgAxMfi3NTn7qPKI4OEf7lpDJlo00i0-PhpqBrY6yMyqkclbAAMcMdApOCYn32b_Y9og2jZlp5WPT3swU_vVvPYm35UNmWbepLSwzTTPfolzoU4sjSHQ3RGrfHk5RSVtZD1JaRMvKjUTEPtqDL5MQ
export PMSJWT=eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiYWRtaW4iOnRydWUsImlhdCI6MTUxNjIzOTAyMiwiaXNzIjoicG1zLWlzc3VlciJ9.jU_F_d9HCZD6m8jElHSR-SN2c_VTIJYvARBF79iN8kMAhYlOErkXSDfa9sbQNSHGJjxIL2sKKq05XPVBRUpL71nqIjU6nSvRYrfkjXgexag5kz5euYu6St2aiT1oMT20tI5PGN4sWSrjhYDIplJByXtW-00cT6pkR4at0G9AZmfx8SOm9kaeRiC1M8dXxHWwKYCDLLY3ENE7dXRcpwNcMXJ--aJ_DF5Lojr1VpmODsrX7Nc4qbnQl6oxnH81TsAawA48ULEnsAbLMzV89rZK_vUHAG6pkDGxqJZkOhOkRBKAFdmaDqLrGjA3J2NdntOo2haxMXQc7RESArqpP3MUjQ
export ECSJWT=eyJhbGciOiJSUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiYWRtaW4iOnRydWUsImlhdCI6MTUxNjIzOTAyMiwiaXNzIjoiZWNzLWlzc3VlciJ9.FIoI0vBNH5VdLd1HThhYWVNmfipqOEnaZsG10ze4mB8vqYHjeS27FKDh9BAqhcks935SbTj6Imkv4viKF60rT8X8IZr4iJdfFYvWkqo4V0YX_zmooqwJFQFW0FzO4Y-_Wr9gNHvuODEyRfjsa3CZz52pnSquaAO7YWcMjRxh3z6AzB3Tsfqaf768ms1NHozEHF3o__opkrpvtcplZucUgwquyx8GlR6LC9mECgtM_gQLLVMqa_gxFi5Puy5X7VOybp9W7lDYkUSJmgb8b8qPFvpjdUEZ8tSw-Gfk0wK6go6lRv3vmfHhom1Nf0nsmYkBnoIbw4nTqYhBa1ulswfPEQ


echo "Create JWT KongPlugin in nonrtric namespace"
echo '
apiVersion: configuration.konghq.com/v1
kind: KongPlugin
metadata:
  name: app-jwt-kp
  namespace: nonrtric
plugin: jwt
' | kubectl apply -f -

echo "Create secret, public key, for pms-user JWT"

# echo -n '
# apiVersion: v1
# kind: Secret
# metadata:
#   name: pms-jwt-sec
#   namespace: nonrtric
# type: Opaque
# stringData:
#   kongCredType: jwt
#   key: "pms-issuer"
#   algorithm: RS256
#   rsa_public_key: "-----BEGIN PUBLIC KEY-----
# MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwetu4+suoz6c7e1kQz7I
# Jmujci8zHpp4qh3nsmEL8e3QOKzMVsLuQPcF8lO1bBoChSA+KMNJ5rEixGWSxClp
# 9XroBSgrvjDsKtpPIlBQMnyOUYRSXWnIodmN+7wA72pTxo7JtAypPzRscSgi0OZt
# 9dtmv50RLr9Wph5cI+IE9OtgW58OKtdFRGigGHfdUEwrT/MPw2rOU85YRFaEgT/i
# wcuQCe+Zmf2S2gVgK62u51ZFFn2VycJT1LcOt9cdqrSXYZAPfVKnQ/EgYvDdzFL1
# x73JkrrSEP3pfrN4bXOnc7cS/S9Y2qk/I+QCR6a6XKmqk5SnWJSyXvKdYQJrgxJp
# lQIDAQAB
# -----END PUBLIC KEY-----"
# ' | kubectl apply -f -

kubectl create secret \
  generic pms-jwt-sec  -n nonrtric \
  --from-literal=kongCredType=jwt  \
  --from-literal=key="pms-issuer" \
  --from-literal=algorithm=RS256 \
  --from-literal=rsa_public_key="-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwetu4+suoz6c7e1kQz7I
Jmujci8zHpp4qh3nsmEL8e3QOKzMVsLuQPcF8lO1bBoChSA+KMNJ5rEixGWSxClp
9XroBSgrvjDsKtpPIlBQMnyOUYRSXWnIodmN+7wA72pTxo7JtAypPzRscSgi0OZt
9dtmv50RLr9Wph5cI+IE9OtgW58OKtdFRGigGHfdUEwrT/MPw2rOU85YRFaEgT/i
wcuQCe+Zmf2S2gVgK62u51ZFFn2VycJT1LcOt9cdqrSXYZAPfVKnQ/EgYvDdzFL1
x73JkrrSEP3pfrN4bXOnc7cS/S9Y2qk/I+QCR6a6XKmqk5SnWJSyXvKdYQJrgxJp
lQIDAQAB
-----END PUBLIC KEY-----"



echo "Create secret, public key, for ecs-user JWT"
kubectl create secret \
  generic ecs-jwt-sec  -n nonrtric \
  --from-literal=kongCredType=jwt  \
  --from-literal=key="ecs-issuer" \
  --from-literal=algorithm=RS256 \
  --from-literal=rsa_public_key="-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAtminzTtNs5oqPCbg4uC1
L7MfR3B+uyYvkSKr3NFieRCxp6VhrgodJJXYc3SqXbaTVBkTwU24wG4UvJCnoRQd
0VhSawtLkN8XNAdCiD831dKUYMJPs43ZY/gO5CHVqUMdSHlp8dn7jNren59dvRRS
3xC1D3etXuEU01XGuLi/5qJLAKqDbYs3bH1vslTjndg1WTsrkU8GEIT1NphSYg25
s6rSLTIBfk8FjKquYHw3wYVSQK9rg2mqddJpRWkfZnazMHTmSNjOJpiNb77VLGSx
9qDbbLjurCl2mAG5Z+w76uKfKGgOo68SU0TL1sPybsKhAoZZg1gF06mvMln5eq5C
RQIDAQAB
-----END PUBLIC KEY-----"


kubectl create secret \
  generic app-admin-jwt-sec  -n nonrtric  \
  --from-literal=kongCredType=jwt  \
  --from-literal=key="admin-issuer" \
  --from-literal=algorithm=RS256 \
  --from-literal=rsa_public_key="-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAtBf2B5fMbGX/IOQDdpx7
z3V+96Nu9Fq+h05K86MtTnT93lVmfToeTfegL9B1ImKGBveBu2wzEna0TTX5NXRS
plR35Rhs9BAiUDwMsUI7rcUvkz3vMjj3JstV2TBHiUcQ/3ZkNtvE3PjvQP7Wv/D2
DOSoubHFtdJEwx8tprnreshAylSC4ZZExnj26j0jT4WMvPJFT18vt/DY2YOVDQ1p
IjEr9Rpvfp4fcqGZ64eomdWgbrZ4bYFkxcBKezVoQLty84UUrkjJrpq2O70Vo2E1
+Hbbo99FJ31w7UalQVjzFYPsDuaS8NEnbpU8xKYeSJXBatWnBW/h9WJRKWkkBVER
OQIDAQAB
-----END PUBLIC KEY-----"



kubectl create secret \
  generic app-user-jwt-sec  \
  --from-literal=kongCredType=jwt  -n nonrtric  \
  --from-literal=key="user-issuer" \
  --from-literal=algorithm=RS256 \
  --from-literal=rsa_public_key="-----BEGIN PUBLIC KEY-----
MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAqeYpS4N/1HzITPnBjdoI
bUT9sMwwlKxsoZ4ry6XIBfGnUel5zeYKjq/3Q3457RnZXOGyFrZ30X5PrWN57wUF
GIY9C/r+8bYgPyuox11TOrlEbvzbLWvZjwqEpqV+d9y/u6oJOZnaNqA/TLFB+NoS
93xwGWOPuRLcgpHyFKoroycCr00t600lWTJvyWp41HoNOtoHzuKIlYlKnr50PaXd
U1C312zkokjDH7zPxNoyxRZeOugs4FLhOfafUoFEa1LCiEGYc3PUbIESEdUBHF9/
Eo0dfrY95YYiBjlok7TmXiUMKmdXWWEZNq/21r4IeZXOdyIeBNjLPakuwu3TNxNA
OQIDAQAB
-----END PUBLIC KEY-----"





echo "Create ACL KongPlugin for PMS group"
echo "
apiVersion: configuration.konghq.com/v1
kind: KongPlugin
metadata:
  name: pms-group-acl-kp
  namespace: nonrtric
plugin: acl
config:
  whitelist: ['pms-group']
" | kubectl apply -f -

echo "Create seccret for PMS group"
kubectl create secret \
  generic pms-group-acl-sec -n nonrtric \
  --from-literal=kongCredType=acl  \
  --from-literal=group=pms-group

echo "Create ACL KongPlugin for ECS group"
echo "
apiVersion: configuration.konghq.com/v1
kind: KongPlugin
metadata:
  name: ecs-group-acl-kp
  namespace: nonrtric
plugin: acl
config:
  whitelist: ['ecs-group']
" | kubectl apply -f -

echo "Create seccret for ECS group"
kubectl create secret \
  generic ecs-group-acl-sec -n nonrtric \
  --from-literal=kongCredType=acl  \
  --from-literal=group=ecs-group


echo "Create KongConsumer for pms-user"
echo "
apiVersion: configuration.konghq.com/v1
kind: KongConsumer
metadata:
  name: pms-user-kc
  namespace: nonrtric
  annotations:
    kubernetes.io/ingress.class: kong
username: pms-user
credentials:
  - pms-jwt-sec
  - pms-group-acl-sec
" | kubectl apply -f -

echo "Create KongConsumer for ecs-user"
echo "
apiVersion: configuration.konghq.com/v1
kind: KongConsumer
metadata:
  name: ecs-user-kc
  namespace: nonrtric
  annotations:
    kubernetes.io/ingress.class: kong
username: ecs-user
credentials:
  - ecs-jwt-sec
  - ecs-group-acl-sec
" | kubectl apply -f -


echo "
apiVersion: configuration.konghq.com/v1
kind: KongConsumer
metadata:
  name: admin-kc
  namespace: nonrtric
  annotations:
    kubernetes.io/ingress.class: kong
username: admin
credentials:
  - app-admin-jwt-sec
" | kubectl apply -f -

echo "
apiVersion: configuration.konghq.com/v1
kind: KongConsumer
metadata:
  name: plain-user-kc
  namespace: nonrtric
  annotations:
    kubernetes.io/ingress.class: kong
username: plain-user
credentials:
  - app-user-jwt-sec
" | kubectl apply -f -


echo "Create ingress for PMS"
echo '
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: r1-pms-ing
  namespace: nonrtric
  annotations:
    konghq.com/plugins: app-jwt-kp,pms-group-acl-kp
#    konghq.com/plugins: app-jwt-kp
    konghq.com/strip-path: "false"
spec:
  ingressClassName: kong
  rules:
  - http:
      paths:
      - path: /a1-policy
        pathType: ImplementationSpecific
        backend:
          service:
            name: policymanagementservice
            port:
              number: 8081
' | kubectl apply -f -

echo "Create ingress for ECS"
echo '
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: r1-ecs-ing
  namespace: nonrtric
  annotations:
    konghq.com/plugins: app-jwt-kp,ecs-group-acl-kp
#    konghq.com/plugins: app-jwt-kp
    konghq.com/strip-path: "false"
spec:
  ingressClassName: kong
  rules:
  - http:
      paths:
      - path: /data-consumer
        pathType: ImplementationSpecific
        backend:
          service:
            name: enrichmentservice
            port:
              number: 8083
      - path: /data-producer
        pathType: ImplementationSpecific
        backend:
          service:
            name: enrichmentservice
            port:
              number: 8083
' | kubectl apply -f -

echo "Create ingress for demo-get"
echo '
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: demo-get-ing
  namespace: nonrtric
  annotations:
    konghq.com/plugins: app-jwt-kp
    konghq.com/strip-path: "false"
spec:
  ingressClassName: kong
  rules:
  - http:
      paths:
      - path: /get
        pathType: ImplementationSpecific
        backend:
          service:
            name: httpbin
            port:
              number: 80
' | kubectl apply -f -

echo "Create ingress for demo-post"
echo '
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: demo-post-ing
  namespace: nonrtric
  annotations:
    konghq.com/plugins: app-jwt-kp
    konghq.com/strip-path: "false"
spec:
  ingressClassName: kong
  rules:
  - http:
      paths:
      - path: /post
        pathType: ImplementationSpecific
        backend:
          service:
            name: httpbin
            port:
              number: 80
' | kubectl apply -f -